﻿SpeakinSpell = LibStub("AceAddon-3.0"):GetAddon("SpeakinSpell")

-- load localized text including default speeches
local L					= LibStub("AceLocale-3.0"):GetLocale("SpeakinSpell",					false)


-------------------------------------------------------------------------------
-- GENERAL INITIALIZATION AND MAIN ENTRY POINTS
-------------------------------------------------------------------------------



function SpeakinSpell:ResetToDefaults(FrameName) --TODOFUTURE: reset only the current frame's defaults (optionally)
	SpeakinSpellSavedData.EventTable = nil
	
	-- copy defaults into current settings using class-specific defaults
	self:InitDefaultSavedData()
	
	-- update/reset runtime data state
	self:InitRuntimeData()
	self:CurrentMessagesGUI_RebuildSpellList() -- this might be redundant but doesn't seem to hurt
	
	-- if the options GUI is showing right now, we need to refresh it to make it show the new data
	self:RefreshFrame("General")
	self:RefreshFrame("CreateNew")
	self:RefreshFrame("CurrentMessagesGUI")
	
	self:Print(L["Default settings restored"])
end




function SpeakinSpell:OnInitialize()
    -- Called when the addon is loaded

	self:RegisterAllEvents()
	self:RegisterChatCommands()	-- register chat commands
	-- the rest of the initialization does not occur until VARIABLES_LOADED
	
	-- done loading
    self:Print( string.format(L["Loaded version %s"], self.CURRENT_VERSION) )
end


function SpeakinSpell:OnEnable()
	-- Called when the addon is enabled
	-- self:RegisterAllEvents() -- did this OnInitialize
	self:CurrentMessagesGUI_RebuildSpellList() -- make sure the options GUI is setup correctly
end


function SpeakinSpell:OnDisable()
    -- Called when the addon is disabled
	-- we don't need to do anything here
end

